#include <iostream>
#include <fstream>
#include <stdlib.h>
//Bibliotheke fuer die Zeit Abmessung
________________________________
using namespace std;

#define NUM_ITEMS 4205

//DEKLARATION EINIGER NTZLICHEN FUNKTIONEN
void readData (float speeds[], int array_size, char fileName[]);
void writeData (float speeds[], int array_size, char fileName[]);
void selectionSort (float speeds[], int array_size);
void bubbleSort(float speeds[], int array_size);

int main(void)
{
  int i;
  clock_t ________________________;   //Variable zum Speichern des Anfangszeit
  clock_t ________________________;   //Variable zum Speichern des Endzeit
  clock_t ticks; //Variable fuer die Ticksanzahl

  float sek; //Variable fuer die Sekunden
  float speeds[NUM_ITEMS];
  char dateiName[20] = "Autobahn4205.dat";

  //***********************************************************
  //* SORTIERUNG
  //************************************************************
  //Zufllige Initialisierung des Vektors
  readData ( speeds, NUM_ITEMS, dateiName );
   
  //Abruf der CPU Zeit am Anfang
  _________________________________
 //FUNKTION fr BUBBLESORT Sortierung 
  bubbleSort(speeds, NUM_ITEMS);
  //Abruf der CPU Zeit am Ende
  ___________________________________

  //Speicher der sortierten Daten in der Datei
   writeData ( speeds, NUM_ITEMS, "Autobahn4205_Sortiert.dat"); 
  
  //Berechnung der Inkrement von CPU Ticks  
  ___________________________________
  
  
  //Umwandlung in Sekunden
  ______________________________________
  
  //Ausgabe 
  cout<< "Die Zeit verwendet fuer die Sortierung betraegt:" << endl;
  _____________________________________________________________
  cout << endl;
  
  system("PAUSE");
  return 0;
}


//***********************************************
//*DEFINITION DER FUNKTIONEN
//***********************************************

void readData (float speeds[], int array_size, char fileName[])
{
   unsigned i;
   ifstream leseStrom;
   
   leseStrom.open(fileName);
   
   for ( i= 0; i < 4205; i++ )
   {
       leseStrom >> speeds[i];
   }  
   
   leseStrom.close();
   
}

void writeData (float speeds[], int array_size, char fileName[])
{
   unsigned i;
   ofstream schreibStrom;
   
   schreibStrom.open(fileName);
   
   for ( i= 0; i < 4205; i++ )
   {
       schreibStrom << speeds[i] << "\n";
   }  
   
   schreibStrom.close();   
}

void selectionSort(float speeds[], int array_size)
{
  int i, j;
  int min;
  float temp;

  for (i = 0; i < array_size-1; i++)
  {
    min = i;
    for (j = i+1; j < array_size; j++)
    {
      if (speeds[j] < speeds[min])
        min = j;
    }
    temp = speeds[i];
    speeds[i] = speeds[min];
    speeds[min] = temp;
  }
}

void bubbleSort(float speeds[], int array_size)
{
  int i, j;
  float temp;

  for (i = (array_size - 1); i >= 0; i--)
  {
    for (j = 1; j <= i; j++)
    {
      if (speeds[j-1] > speeds[j])
      {
        temp = speeds[j-1];
        speeds[j-1] = speeds[j];
        speeds[j] = temp;
      }
    }
  }
}
